    var myInterpreter = null;
    var runner;

    $(function () {
    	//標準のボタン
    	$("#btn_run").button();
    	$("#btn_gen").button();
    	$("#btn_load").button();
    	$("#btn_save").button();
    	$("#btn_new").button();
			$("#btn_ret").button();

    });


    //Auto update Highlight function added
    demoWorkspace.addChangeListener(function (event) {
    	if (!(event instanceof Blockly.Events.Ui)) {
    		// Something changed. Parser needs to be reloaded.
    		resetInterpreter();
    		generateCodeAndLoadIntoInterpreter();
    	}
		});
		
		function returnToHome()
		{
			window.location.href = "/SD_WLAN/List.htm";
		}


    function destroyClickedElement(event) {
    	// remove the link from the DOM
    	document.body.removeChild(event.target);
    }

    function SaveXML() {
    	var xmlDom = Blockly.Xml.workspaceToDom(demoWorkspace);
    	var xmlText = Blockly.Xml.domToPrettyText(xmlDom);

    	var textToWrite = xmlText;
    	var textFileAsBlob = new Blob([textToWrite], {
    		type: 'text/plain'
    	});
    	var fileNameToSaveAs = "userseqs.xml";

    	var downloadLink = document.createElement("a");
    	downloadLink.download = fileNameToSaveAs;
    	downloadLink.innerHTML = "My Hidden Link";

    	window.URL = window.URL || window.webkitURL;

    	// Create the link Object.
    	downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
    	downloadLink.onclick = destroyClickedElement;
    	downloadLink.style.display = "none";
    	document.body.appendChild(downloadLink);

    	downloadLink.click();


    }

    function NewXML() {

    	var buttons = [{
    			text: "はい",
    			click: function () {
    				demoWorkspace.clear();
    				$(this).dialog('close');
    			}
    		},
    		{
    			text: "いいえ",
    			click: function () {
    				$(this).dialog('close');
    			}
    		}
    	];
    	// ダイアログを表示
    	showDialog("さいしょからつくる", "いまあるブロックを消しても良いですか？", buttons);



    }

    function LoadXML() {


    	const showOpenFileDialog = () => {
    		return new Promise(resolve => {
    			const input = document.createElement('input');
    			input.type = 'file';
    			input.accept = '.xml, text/plain';
    			input.onchange = event => {
    				resolve(event.target.files[0]);
    			};
    			input.click();
    		});
    	};

    	const readAsText = file => {
    		return new Promise(resolve => {
    			const reader = new FileReader();
    			reader.readAsText(file);
    			reader.onload = () => {
    				resolve(reader.result);
    			};
    		});
    	};

    	(async () => {
    		const file = await showOpenFileDialog();
    		const content = await readAsText(file);
    		// 内容表示
    		//alert(content);

    		xmlText = content;
    		try {
    			xmlDom = Blockly.Xml.textToDom(xmlText);
    		} catch (e) {
    			alert("Load Error");
    		}

    		if (xmlDom) {
    			demoWorkspace.clear();
    			Blockly.Xml.domToWorkspace(xmlDom, demoWorkspace);
    		}

    	})();

		}

    function showDialog(title, message, buttons) {
    	var esc_str = $('<dummy>').text(message).html().replace(/\r\n|\r|\n/g, '<br>');

    	var html_dialog = '<div>' + esc_str + '</div>';
    	$(html_dialog).dialog({
    		title: title,
    		buttons: buttons,
    		width: "40%",
    		maxWidth: "400px",
    		maxHeight: "360px",
    		height: 'auto',
    		close: function () {
    			$(this).remove();
    		}
    	});
    }

    function showCode() {
    	// Generate JavaScript code and display it.
    	Blockly.JavaScript.INFINITE_LOOP_TRAP = null;
    	var code = Blockly.JavaScript.workspaceToCode(demoWorkspace);

    	var buttons = [{
    		text: "OK",
    		click: function () {
    			$(this).dialog('close');
    		}
    	}];
    	// ダイアログを表示
    	showDialog("Generated code", code, buttons);
    }

    /**
     * Register the interpreter asynchronous function
     * <code>waitForSeconds()</code>.
     */
    function initInterpreterWaitForSeconds(interpreter, scope) {
    	Blockly.JavaScript.addReservedWords('Sleep');

    	var wrapper = interpreter.createAsyncFunction(
    		function (timeInSeconds, callback) {
    			// Delay the call to the callback.
    			setTimeout(callback, timeInSeconds * 1000);
    		});
    	interpreter.setProperty(scope, 'Sleep', wrapper);
    }

    function initApi(interpreter, scope) {
    	// Add an API function for the alert() block, generated for "text_print" blocks.
    	var wrapper = function (text) {
    		text = text ? text.toString() : '';
    		outputArea.value = outputArea.value + '\n' + text;
    	};

    	interpreter.setProperty(scope, 'alert', interpreter.createNativeFunction(wrapper));

    	// Add an API function for the prompt() block.
    	var wrapper = function (text) {
    		text = text ? text.toString() : '';
    		return interpreter.createPrimitive(prompt(text));
    	};

    	interpreter.setProperty(scope, 'prompt',
    		interpreter.createNativeFunction(wrapper));

    	// Add an API for the wait block.  See wait_block.js
    	initInterpreterWaitForSeconds(interpreter, scope);

    	// Add an API function for highlighting blocks.
    	var wrapper = function (id) {
    		id = id ? id.toString() : '';
    		return interpreter.createPrimitive(highlightBlock(id));
    	};

    	interpreter.setProperty(scope, 'highlightBlock', interpreter.createNativeFunction(wrapper));

			Blockly.JavaScript.addReservedWords('CommandPower');
			Blockly.JavaScript.addReservedWords('CommandLocSpeed');
			Blockly.JavaScript.addReservedWords('CommandGetS88');


    	interpreter.setProperty(scope, 'CommandPower', interpreter.createNativeFunction(CommandPower));
    	interpreter.setProperty(scope, 'CommandGetS88', interpreter.createNativeFunction(CommandGetS88));
    	interpreter.setProperty(scope, 'CommandLocSpeed', interpreter.createNativeFunction(CommandLocSpeed));
    	interpreter.setProperty(scope, 'CommandLocDirection', interpreter.createNativeFunction(CommandLocDirection));
    	interpreter.setProperty(scope, 'CommandTurnout', interpreter.createNativeFunction(CommandTurnout));
    	interpreter.setProperty(scope, 'CommandLocFunction', interpreter.createNativeFunction(CommandLocFunction));
    	interpreter.setProperty(scope, 'CommandGetS88Data', interpreter.createNativeFunction(CommandGetS88Data));
    	interpreter.setProperty(scope, 'GetSlotAdress', interpreter.createNativeFunction(GetSlotAdress));
    	interpreter.setProperty(scope, 'playSound', interpreter.createNativeFunction(playSound));
    	interpreter.setProperty(scope, 'stopSound', interpreter.createNativeFunction(stopSound));
    	interpreter.setProperty(scope, 'GetSlotFnc', interpreter.createNativeFunction(GetSlotFnc));

    }

    var highlightPause = false;
    var latestCode = '';

    function highlightBlock(id) {
    	demoWorkspace.highlightBlock(id);
    	highlightPause = true;
    }

    function resetStepUi(clearOutput) {
    	demoWorkspace.highlightBlock(null);
    	highlightPause = false;
    	//runButton.disabled = '';
    	if (clearOutput) {
    		//outputArea.value = 'Program output:\n=================';
    	}
    }

    function generateCodeAndLoadIntoInterpreter() {
    	// Generate JavaScript code and parse it.
    	Blockly.JavaScript.STATEMENT_PREFIX = 'highlightBlock(%1);\n';
    	Blockly.JavaScript.addReservedWords('highlightBlock');
    	latestCode = Blockly.JavaScript.workspaceToCode(demoWorkspace);
    	resetStepUi(true);
    }

    function resetInterpreter() {
    	myInterpreter = null;

    	if (runner) {
    		clearTimeout(runner);
    		runner = null;
    	}
    }

    // Load the interpreter now, and upon future changes.
    generateCodeAndLoadIntoInterpreter();


    function runCode() {


    	if (!myInterpreter) {

    		// First statement of this code.

    		// Clear the program output.
    		resetStepUi(true);
    		//runButton.disabled = 'disabled';

    		// And then show generated code in an alert.
    		// In a timeout to allow the outputArea.value to reset first.
    		setTimeout(function () {
    			alert('Ready to execute the following code\n' +
    				'===================================\n' +
    				latestCode);

    			// Begin execution
    			highlightPause = false;

    			myInterpreter = new Interpreter(latestCode, initApi);

    			runner = function () {
    				if (myInterpreter) {
    					var hasMore = myInterpreter.run();
    					if (hasMore) {
    						// Execution is currently blocked by some async call.
    						// Try again later.
    						//setTimeout(runner, 100);
    					} else {
    						// Program is complete.
    						//outputArea.value += '\n\n<< Program complete >>';

    						//Stop runner();
    						clearInterval(runner);
    						resetInterpreter();
    						resetStepUi(false);
    					}
    				}
    			};

    			setInterval(runner, 250);

    		}, 1);

    		return;
    	}
    }